clear all
clc
syms x y
 
n=1

st=0.001
fpath1='E:\2022-02\matlab_skyrmion_loc_check\'
fpath2='E:\2022-01\0.03damp_step0.001_data\x_location\'
fpath3='E:\2022-02\M0\'   %
 
 
 s1 = ([fpath3,'xyloc.txt'] );
   xyloc=load(s1) %load xy location at certain time
  [m,o] = size(xyloc)
 
s=1
e=2
for d=s:e
    a=xyloc(d,1)*1000
    b=a+30
    n=1
 for kk=a:b;
     i=kk
     
    s = ([fpath2, num2str(kk),'.txt']);
    A=load(s)
    x_loc=A(450:550,1)./1e-9
    m_x=A(450:550,2)
    m_y=A(450:550,3)
    m_z=A(450:550,4)
    tancone=sqrt(m_x.*m_x+m_y.*m_y)./m_z
    angle_cone=atand(tancone)
    taninplane=m_x./m_y
    angle_inplane=atand(taninplane)
    m_zmin=(-m_z+11e5)./1e5%(300:1000,1)
 
   % m_zmin(1:12)=0
   % m_zmin(92:100)=0
    %x_loc=A(1:1000,1)
    vv=x_loc(2:100,:)
    x=vv
    y=m_zmin
    daom_zmin=-diff(y,2) %2nd diff of m_zmin
    daom_zmin(daom_zmin>0)=0
    daom_zmin=-daom_zmin
    
    %daom_zmin(1:417)=0
   % daom_zmin(972:1000)=0
    [pks2nd,locs2nd] = findpeaks(daom_zmin,'MinPeakHeight',0.06);%3.5e27);
    width_normal(kk)=x_loc(locs2nd(end))-x_loc(locs2nd(1))
    width_normalp(n)=x_loc(locs2nd(end))-x_loc(locs2nd(1))
    width_normal=width_normal.'
    %filename3=['coneangle_' num2str(kk) '.txt']
   %fid = fopen([fpath1,filename3],'wt');
    %fprintf(fid,'%.6f\n',angle_cone)%,'%g\t',dis);    
  %  fclose(fid);
    %filename4=['inplane_angle_' num2str(kk) '.txt']
   % fid = fopen([fpath1,filename4],'wt');
    %fprintf(fid,'%.6f\n',angle_inplane)%,'%g\t',dis);    
   % fclose(fid);
    %amp_in_loc(kk)=locs2nd(1)-1
    %amp_cone(kk)=angle_cone(amp_in_loc(kk))
    %amp_cone_close(kk)=angle_cone(locs2nd(1))
   
    %amp_inplane_close(kk)=angle_inplane(locs2nd(1))
     G2=lrskyrmionedge(vv, daom_zmin)%per1
     
    coeffvalsnomA1(kk,:) = coeffvalues(G2)
    leftedge(n,1)=coeffvalsnomA1(kk,2)%/1e4,-3)
    rightedge(n,1)=coeffvalsnomA1(kk,5)%/1e4,-3)
    ci = confint(G2)
    sderror(n,1)= ((coeffvalsnomA1(kk,2)-ci(1,2))^2+(coeffvalsnomA1(kk,5)-ci(1,5))^2)^0.5
    %phas=coeffvalsnomA1(1,1)

    width=leftedge-rightedge
    
   
 str=['running', num2str(i/b*100),'%'];
  n=n+1
 end
 widthave=mean(width)
 widthp(d,1)=widthave
 simulation_time(d)=xyloc(d,1)

end
 %simulation_time=st*s:st:(st*e); %=start time: step :end time
%simulation_time=simulation_time.'
plot(simulation_time,widthp);
xlabel('simulation time (ns)')
ylabel('skyrmion width on x axis (nm)')
filename1=['skyrmion width_' num2str(a) '-' num2str(b) '.txt']
fid = fopen([fpath1,filename1],'wt');
fprintf(fid,'%.6f\n',width)%,'%g\t',dis);    
fclose(fid);
filename2=['skyrmion normal width_' num2str(a) '-' num2str(b) '.txt']
fid = fopen([fpath1,filename2],'wt');
fprintf(fid,'%.6f\n',width_normal)%,'%g\t',dis);    
fclose(fid);

function [fitresult, gof] = Gaussfit(x_loc, m_zmin)
%CREATEFIT(X_LOC,M_ZMIN)
%  Create a fit.
%
%  Data for 'untitled fit 1' fit:
%      X Input : x_loc
%      Y Output: m_zmin
%  Output:
%      fitresult : a fit object representing the fit.
%      gof : structure with goodness-of fit info.
%
%  See also FIT, CFIT, SFIT.

%  Auto-generated by MATLAB on 08-Feb-2022 22:51:06


%% Fit: 'untitled fit 1'.
[xData, yData] = prepareCurveData( x_loc, m_zmin );

% Set up fittype and options.
ft = fittype( 'a1*exp(-((x-b1)/c1)^2)+d', 'independent', 'x', 'dependent', 'y' );
opts = fitoptions( 'Method', 'NonlinearLeastSquares' );
opts.Display = 'Off';
opts.StartPoint = [0.489764395788231 0.445586200710899 0.646313010111265 1];

% Fit model to data.
[fitresult, gof] = fit( xData, yData, ft, opts );

% Plot fit with data.
figure( 'Name', 'untitled fit 1' );
h = plot( fitresult, xData, yData );
legend( h, 'm_zmin vs. x_loc', 'untitled fit 1', 'Location', 'NorthEast', 'Interpreter', 'none' );
% Label axes
xlabel( 'x_loc', 'Interpreter', 'none' );
ylabel( 'm_zmin', 'Interpreter', 'none' );
grid on
end

function [fitresult, gof] = lrskyrmionedge(vv, daom_zmin)
  
[xData, yData] = prepareCurveData( vv, daom_zmin );

% Set up fittype and options.
ft = fittype( 'gauss2' );
opts = fitoptions( 'Method', 'NonlinearLeastSquares' );
opts.Display = 'Off';
opts.Lower = [0.01 -Inf 0 0.01 -Inf 0];
opts.StartPoint = [0.11162865098982 10 3.22498757366428 0.102250073363637 -10 3.76131425792323];

% Fit model to data.
[fitresult, gof] = fit( xData, yData, ft, opts );

% Plot fit with data.
figure( 'Name', 'untitled fit 1' );
h = plot( fitresult, xData, yData );
legend( h, 'daom_zmin vs. vv', 'untitled fit 1', 'Location', 'NorthEast', 'Interpreter', 'none' );
% Label axes
xlabel( 'vv', 'Interpreter', 'none' );
ylabel( 'daom_zmin', 'Interpreter', 'none' );
grid on
end